import React from "react";
export interface CardProps {
    children?: React.ReactNode;
    height?: number;
    className?: string;
    backgroundColor?: string;
}
export interface CardHandler {
    highlight: (color: string) => void;
    cardRef: React.RefObject<HTMLDivElement>;
}
declare const Card: React.ForwardRefExoticComponent<CardProps & React.RefAttributes<CardHandler>> & {
    Footer: React.FC<{
        children: React.ReactNode;
        className?: string | undefined;
    } & React.AriaAttributes>;
    Header: React.FC<{
        children: React.ReactNode;
        className?: string | undefined;
    } & React.AriaAttributes>;
    Content: React.FC<{
        children: React.ReactNode;
        className?: string | undefined;
    } & React.AriaAttributes>;
};
export default Card;
