import { AccessorySelectorProps } from "./AccessorySelector";
import { DropdownProps } from "../common/DropdownListMenu";
import { IconProps } from "../common/Icon";
import { LinkWithAction, SecretIdentityType, UserIdentityType } from "../types";
import React from "react";
export declare enum UserMetadataStyle {
    REGULAR = "REGULAR",
    COMPACT = "COMPACT"
}
export interface UserMetadataProps extends Partial<AccessorySelectorProps> {
    secretIdentity?: SecretIdentityType;
    userIdentity?: UserIdentityType;
    forceHideIdentity?: boolean;
    withDropdownMetadata?: boolean;
    avatarDropdownOptions?: DropdownProps["options"];
    avatarDropdownLabel?: string;
    identityDropdownLabel?: string;
    identityOptions?: DropdownProps["options"];
    createdMessage?: string;
    createdMessageIcon?: IconProps["icon"];
    createdMessageLink?: LinkWithAction;
    size?: UserMetadataStyle;
}
declare const UserMetadata: React.ForwardRefExoticComponent<UserMetadataProps & React.RefAttributes<HTMLImageElement>>;
export default UserMetadata;
